org.apache.lucene.queries

## Class CustomScoreProvider

- java.lang.Object
- - org.apache.lucene.queries.CustomScoreProvider

    public class CustomScoreProvider
    extends Object

An instance of this subclass should be returned by `CustomScoreQuery.getCustomScoreProvider(org.apache.lucene.index.LeafReaderContext)`, if you want to modify the custom score calculation of a `CustomScoreQuery`.

Since Lucene 2.9, queries operate on each segment of an index separately, so the protected `context` field can be used to resolve doc IDs, as the supplied `doc` ID is per-segment and without knowledge of the IndexReader you cannot access the document or DocValues.

Since:
  2.9.2
WARNING: This API is experimental and might change in incompatible ways in the next release.

### Field Summary

Fields
`protected LeafReaderContext` `context`

### Constructor Summary

Constructors
Constructor and Description
`CustomScoreProvider(LeafReaderContext context)` Creates a new instance of the provider class for the given `IndexReader`.

### Method Summary

All Methods Instance Methods Concrete Methods
`Explanation` `customExplain(int doc, Explanation subQueryExpl, Explanation valSrcExpl)` Explain the custom score.
`Explanation` `customExplain(int doc, Explanation subQueryExpl, Explanation[] valSrcExpls)` Explain the custom score.
`float` `customScore(int doc, float subQueryScore, float valSrcScore)` Compute a custom score by the subQuery score and the `FunctionQuery` score.
`float` `customScore(int doc, float subQueryScore, float[] valSrcScores)` Compute a custom score by the subQuery score and a number of `FunctionQuery` scores.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### context

    protected final LeafReaderContext context

### Constructor Detail

#### CustomScoreProvider

    public CustomScoreProvider(LeafReaderContext context)

Creates a new instance of the provider class for the given `IndexReader`.

### Method Detail

#### customScore

    public float customScore(int doc,
                             float subQueryScore,
                             float[] valSrcScores)
                      throws IOException

Compute a custom score by the subQuery score and a number of `FunctionQuery` scores.

Subclasses can override this method to modify the custom score.

If your custom scoring is different than the default herein you should override at least one of the two customScore() methods. If the number of `function queries` is always < 2 it is sufficient to override the other `customScore()` method, which is simpler.

The default computation herein is a multiplication of given scores:

         ModifiedScore = valSrcScore * valSrcScores[0] * valSrcScores[1] * ...

Parameters:
  `doc` - id of scored doc.
  `subQueryScore` - score of that doc by the subQuery.
  `valSrcScores` - scores of that doc by the `FunctionQuery`.
Returns:
  custom score.
Throws:
  `IOException`

#### customScore

    public float customScore(int doc,
                             float subQueryScore,
                             float valSrcScore)
                      throws IOException

Compute a custom score by the subQuery score and the `FunctionQuery` score.

Subclasses can override this method to modify the custom score.

If your custom scoring is different than the default herein you should override at least one of the two customScore() methods. If the number of `function queries` is always < 2 it is sufficient to override this customScore() method, which is simpler.

The default computation herein is a multiplication of the two scores:

         ModifiedScore = subQueryScore * valSrcScore

Parameters:
  `doc` - id of scored doc.
  `subQueryScore` - score of that doc by the subQuery.
  `valSrcScore` - score of that doc by the `FunctionQuery`.
Returns:
  custom score.
Throws:
  `IOException`

#### customExplain

    public Explanation customExplain(int doc,
                                     Explanation subQueryExpl,
                                     Explanation[] valSrcExpls)
                              throws IOException

Explain the custom score. Whenever overriding `customScore(int, float, float[])`, this method should also be overridden to provide the correct explanation for the part of the custom scoring.

Parameters:
  `doc` - doc being explained.
  `subQueryExpl` - explanation for the sub-query part.
  `valSrcExpls` - explanation for the value source part.
Returns:
  an explanation for the custom score
Throws:
  `IOException`

#### customExplain

    public Explanation customExplain(int doc,
                                     Explanation subQueryExpl,
                                     Explanation valSrcExpl)
                              throws IOException

Explain the custom score. Whenever overriding `customScore(int, float, float)`, this method should also be overridden to provide the correct explanation for the part of the custom scoring.

Parameters:
  `doc` - doc being explained.
  `subQueryExpl` - explanation for the sub-query part.
  `valSrcExpl` - explanation for the value source part.
Returns:
  an explanation for the custom score
Throws:
  `IOException`